# Coveo ResultLayoutSelector Component (CoveoResultLayoutSelector)

The ResultLayoutSelector component allows the end user to switch between multiple ResultList components that have different ResultList.options.layout values.

This component automatically populates itself with buttons to switch between the ResultList components that have a valid layout value (see the ValidLayout type).

See also the Result Layouts documentation.

Available since

  February 2018 Release (v2.3826.10)

## Index

### Methods

- changeLayout
- debugInfo
- disable
- enable
- getBindings
- getCurrentLayout
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- desktopLayouts
- mobileLayouts
- tabletLayouts

### Constructors

- constructor

## Methods

### changeLayout

- changeLayout(layout: ValidLayout): void

- - Defined in ui/ResultLayoutSelector/ResultLayoutSelector.ts :171

  Changes the current layout.

  Also logs a `resultLayoutChange` event in the usage analytics with the new layout as metadeta.

  Triggers a new query.

  #### Parameters

  - ##### layout: ValidLayout

    The new layout. The page must contain a valid ResultList component with a matching ResultList.options.layout value for this method to work.

  #### Returns void

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### getCurrentLayout

- getCurrentLayout(): "list" | "card" | "table"

- - Defined in ui/ResultLayoutSelector/ResultLayoutSelector.ts :180

  Gets the current layout (`list`, `card` or `table`).

  #### Returns "list" | "card" | "table"

  The current current layout.

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### desktopLayouts

desktopLayouts: string[] | ("list" | "card" | "table")[]

- Defined in ui/ResultLayoutSelector/ResultLayoutSelector.ts :120

Specifies the layouts that should be available when the search page is displayed in desktop mode.

By default, the desktop mode breakpoint is any screen size over 800 px.

To change this default value, use the responsiveMediumBreakpoint option.

When the breakpoint is reached, layouts that are not specified becomes inactive and the linked result list will be disabled.

The possible values for layouts are `list`, `card`, `table`.

The default value is `list`, `card`, `table`.

Default

  `[list, card, table]`

### mobileLayouts

mobileLayouts: string[] | ("list" | "card" | "table")[]

- Defined in ui/ResultLayoutSelector/ResultLayoutSelector.ts :92

Specifies the layouts that should be available when the search page is displayed in mobile mode.

By default, the mobile mode breakpoint is at 480 px screen width.

To change this default value, use the responsiveSmallBreakpoint option.

When the breakpoint is reached, layouts that are not specified becomes inactive and the linked result list will be disabled.

The possible values for layouts are `list`, `card`, `table`.

The default value is `card`, `table`.

Default

  `[card, table]`

### tabletLayouts

tabletLayouts: string[] | ("list" | "card" | "table")[]

- Defined in ui/ResultLayoutSelector/ResultLayoutSelector.ts :106

Specifies the layouts that should be available when the search page is displayed in tablet mode.

By default, the tablet mode breakpoint is at 800 px screen width.

To change this default value, use the responsiveMediumBreakpoint option.

When the breakpoint is reached, layouts that are not specified becomes inactive and the linked result list will be disabled.

The possible values for layouts are `list`, `card`, `table`.

The default value is `list`, `card`, `table`.

Default

  `[list, card, table]`

## Constructors

### constructor

- new ResultLayoutSelector(element: HTMLElement, options?: IResultLayoutOptions, bindings?: IComponentBindings): ResultLayoutSelector

- Overwrites Component.constructor

  - Defined in ui/ResultLayoutSelector/ResultLayoutSelector.ts :121

  Creates a new ResultLayoutSelector component.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### Optional options: IResultLayoutOptions

    The options for the ResultLayout component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  #### Returns ResultLayoutSelector